/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#ifndef APP_WINDOW_H
#define APP_WINDOW_H

#include <InterfaceKit.h>
#include <AppKit.h>

//#include "wPacker.h"
#include "pack_view.h"

class KAppWindow;

class KAppMainView : public KPackView {
public:

	virtual void ReadyToPrepare();
	
	virtual void AllAttached(void);
	
private:
	friend KAppWindow;
	
	KAppMainView(BRect frame);
	
};

class KAppWindow : public BWindow {
public:

	KAppWindow(BRect frame,const char *title);
	KAppWindow(BRect frame,
			   const char *title, 
			   window_type type,
			   uint32 flags,
			   uint32 workspace = B_CURRENT_WORKSPACE);
	KAppWindow(BRect frame,
			   const char *title, 
			   window_look look,
			   window_feel feel,
			   uint32 flags,
			   uint32 workspace = B_CURRENT_WORKSPACE);
	//~MainWindow();
	
	bool AddToApp();
	
	bool AddMenu(BMenu *item); // add menu to the menu_bar
	bool AddFileMenu(BMenu *item); // add file menu to the menu_bar
	bool AddApplicationMenu(BMenu *item); // add application menu to the menu_bar
	BMenuBar 	*MainMenuBar();
	BMenu		*FileMenu();
	
	void PackChild(BView *view,
		uint32 side=K_TOP,
		uint32 anchor=K_TOP | K_LEFT,
		uint32 fill=K_FILL_NONE,
		//bool expand=false,
		BPoint border=BPoint(0,0)
		);
		
	KPackView *MainPackView();

	virtual void MessageReceived(BMessage *message);
	virtual void ReadyToPrepare();
	
protected:

	virtual void Init();
	
private:

	BMenuBar		*fMainBar;
	BMenu 			*fFileMenu;
	KPackView		*fMainView;
};

class KApp : public BApplication {
public:
	KApp(const char *signature);
	
	virtual void Quit();
	
	bool AddWindow(BWindow *window);
	
	static	filter_result QuitWindowHook
		(BMessage *message, BHandler **target,BMessageFilter *messageFilter);

private:

	friend KAppWindow;

	static int32	my_app_count_windows;
	
	static KApp *k_app;

};

extern KApp	*my_app;

#endif